/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 */
function Display(e){"use strict";function t(){Util.Debug(">> Display.constructor");var e,t,o,a,r=Util.Engine;if(!l.target)throw"target must be set";if("string"==typeof l.target)throw"target must be a DOM element";if(e=l.target,!e.getContext)throw"no getContext method";if(u||(u=e.getContext("2d")),Util.Debug("User Agent: "+navigator.userAgent),r.gecko&&Util.Debug("Browser: gecko "+r.gecko),r.webkit&&Util.Debug("Browser: webkit "+r.webkit),r.trident&&Util.Debug("Browser: trident "+r.trident),r.presto&&Util.Debug("Browser: presto "+r.presto),n.clear(),!("createImageData"in u))throw"Canvas does not support createImageData";for(l.render_mode="canvas rendering",null===l.prefer_js&&(Util.Info("Prefering javascript operations"),l.prefer_js=!0),g=u.createImageData(16,16),o=[],t=0;256>t;t+=1)o.push(255);try{a=e.style.cursor,changeCursor(l.target,o,o,2,2,8,8),e.style.cursor?(null===l.cursor_uri&&(l.cursor_uri=!0),Util.Info("Data URI scheme cursor supported")):(null===l.cursor_uri&&(l.cursor_uri=!1),Util.Warn("Data URI scheme cursor not supported")),e.style.cursor=a}catch(s){Util.Error("Data URI scheme cursor test exception: "+s),l.cursor_uri=!1}return Util.Debug("<< Display.constructor"),n}var o,a,r,s,i,n={},l={},u=null,d=0,c=0,p={x:0,y:0,w:0,h:0},h={x1:0,y1:0,x2:-1,y2:-1},m="",f=null,g=null,v=0,b=0;return Util.conf_defaults(l,n,e,[["target","wo","dom",null,"Canvas element for rendering"],["context","ro","raw",null,"Canvas 2D context for rendering (read-only)"],["logo","rw","raw",null,'Logo to display when cleared: {"width": width, "height": height, "data": data}'],["true_color","rw","bool",!0,"Use true-color pixel data"],["colourMap","rw","arr",[],"Colour map array (when not true-color)"],["scale","rw","float",1,"Display area scale factor 0.0 - 1.0"],["viewport","rw","bool",!1,"Use a viewport set with viewportChange()"],["width","rw","int",null,"Display area width"],["height","rw","int",null,"Display area height"],["render_mode","ro","str","","Canvas rendering mode (read-only)"],["prefer_js","rw","str",null,"Prefer Javascript over canvas methods"],["cursor_uri","rw","raw",null,"Can we render cursor using data URI"]]),n.get_context=function(){return u},n.set_scale=function(e){i(e)},n.set_width=function(e){n.resize(e,c)},n.get_width=function(){return d},n.set_height=function(e){n.resize(d,e)},n.get_height=function(){return c},i=function(e){var t,o,a,r,s=["transform","WebkitTransform","MozTransform",null];for(t=l.target,o=s.shift();o&&"undefined"==typeof t.style[o];)o=s.shift();return null===o?void Util.Debug("No scaling support"):("undefined"==typeof e?e=l.scale:e>1?e=1:.1>e&&(e=.1),void(l.scale!==e&&(l.scale=e,a=t.width-t.width*e,r=t.height-t.height*e,t.style[o]="scale("+l.scale+") translate(-"+a+"px, -"+r+"px)")))},s=function(e){var t,o;t=l.true_color?e:l.colourMap[e[0]],o="rgb("+t[2]+","+t[1]+","+t[0]+")",o!==m&&(u.fillStyle=o,m=o)},n.viewportChange=function(e,t,o,a){var r,s,i,n,m,f,g,v=l.target,b=p,y=h,w=null;l.viewport||(Util.Debug("Setting viewport to full display region"),e=-b.w,t=-b.h,o=d,a=c),"undefined"==typeof e&&(e=0),"undefined"==typeof t&&(t=0),"undefined"==typeof o&&(o=b.w),"undefined"==typeof a&&(a=b.h),o>d&&(o=d),a>c&&(a=c),(b.w!==o||b.h!==a)&&(o<b.w&&y.x2>b.x+o-1&&(y.x2=b.x+o-1),b.w=o,a<b.h&&y.y2>b.y+a-1&&(y.y2=b.y+a-1),b.h=a,b.w>0&&b.h>0&&v.width>0&&v.height>0&&(w=u.getImageData(0,0,v.width<b.w?v.width:b.w,v.height<b.h?v.height:b.h)),v.width=b.w,v.height=b.h,w&&u.putImageData(w,0,0)),n=b.x+b.w-1,m=b.y+b.h-1,0>e&&b.x+e<0&&(e=-b.x),n+e>=d&&(e-=n+e-d+1),b.y+t<0&&(t=-b.y),m+t>=c&&(t-=m+t-c+1),(0!==e||0!==t)&&(Util.Debug("viewportChange deltaX: "+e+", deltaY: "+t),b.x+=e,n+=e,b.y+=t,m+=t,b.x>y.x1&&(y.x1=b.x),n<y.x2&&(y.x2=n),b.y>y.y1&&(y.y1=b.y),m<y.y2&&(y.y2=m),0>e?(s=0,f=-e):(s=b.w-e,f=e),0>t?(i=0,g=-t):(i=b.h-t,g=t),r=u.fillStyle,u.fillStyle="rgb(255,255,255)",0!==e&&(u.drawImage(v,0,0,b.w,b.h,-e,0,b.w,b.h),u.fillRect(s,0,f,b.h)),0!==t&&(u.drawImage(v,0,0,b.w,b.h,0,-t,b.w,b.h),u.fillRect(0,i,b.w,g)),u.fillStyle=r)},n.getCleanDirtyReset=function(){var e,t=p,o=h,a=[],r=t.x+t.w-1,s=t.y+t.h-1;return e={x:o.x1,y:o.y1,w:o.x2-o.x1+1,h:o.y2-o.y1+1},o.x1>=o.x2||o.y1>=o.y2?a.push({x:t.x,y:t.y,w:t.w,h:t.h}):(t.x<o.x1&&a.push({x:t.x,y:t.y,w:o.x1-t.x+1,h:t.h}),r>o.x2&&a.push({x:o.x2+1,y:t.y,w:r-o.x2,h:t.h}),t.y<o.y1&&a.push({x:o.x1,y:t.y,w:o.x2-o.x1+1,h:o.y1-t.y}),s>o.y2&&a.push({x:o.x1,y:o.y2+1,w:o.x2-o.x1+1,h:s-o.y2})),h={x1:t.x,y1:t.y,x2:t.x+t.w-1,y2:t.y+t.h-1},{cleanBox:e,dirtyBoxes:a}},n.absX=function(e){return e+p.x},n.absY=function(e){return e+p.y},n.resize=function(e,t){m="",d=e,c=t,i(l.scale),n.viewportChange()},n.clear=function(){l.logo?(n.resize(l.logo.width,l.logo.height),n.blitStringImage(l.logo.data,0,0)):(n.resize(640,20),u.clearRect(0,0,p.w,p.h))},n.fillRect=function(e,t,o,a,r){s(r),u.fillRect(e-p.x,t-p.y,o,a)},n.copyImage=function(e,t,o,a,r,s){var i=e-p.x,n=t-p.y,d=o-p.x,c=a-p.y;u.drawImage(l.target,i,n,r,s,d,c,r,s)},n.startTile=function(e,t,o,a,r){var s,i,d,c,p,h;if(v=e,b=t,f=16===o&&16===a?g:u.createImageData(o,a),s=f.data,l.prefer_js)for(i=l.true_color?r:l.colourMap[r[0]],d=i[2],c=i[1],p=i[0],h=0;o*a*4>h;h+=4)s[h]=d,s[h+1]=c,s[h+2]=p,s[h+3]=255;else n.fillRect(e,t,o,a,r)},n.subTile=function(e,t,o,a,r){var s,i,u,d,c,p,h,m,g,y,w;if(l.prefer_js)for(s=f.data,h=f.width,u=l.true_color?r:l.colourMap[r[0]],d=u[2],c=u[1],p=u[0],y=e+o,w=t+a,m=t;w>m;m+=1)for(g=e;y>g;g+=1)i=4*(g+m*h),s[i]=d,s[i+1]=c,s[i+2]=p,s[i+3]=255;else n.fillRect(v+e,b+t,o,a,r)},n.finishTile=function(){l.prefer_js&&u.putImageData(f,v-p.x,b-p.y)},o=function(e,t,o,a,r,s){var i,n,l,d,c=p;for(i=u.createImageData(o,a),d=i.data,n=0,l=s;o*a*4>n;n+=4,l+=3)d[n]=r[l],d[n+1]=r[l+1],d[n+2]=r[l+2],d[n+3]=255;u.putImageData(i,e-c.x,t-c.y)},a=function(e,t,o,a,r,s){var i,n,l,d,c=p;for(i=u.createImageData(o,a),d=i.data,n=0,l=s;o*a*4>n;n+=4,l+=4)d[n]=r[l+2],d[n+1]=r[l+1],d[n+2]=r[l],d[n+3]=255;u.putImageData(i,e-c.x,t-c.y)},r=function(e,t,o,a,r,s){var i,n,d,c,h,m;for(i=u.createImageData(o,a),c=i.data,m=l.colourMap,n=0,d=s;o*a*4>n;n+=4,d+=1)h=m[r[d]],c[n]=h[2],c[n+1]=h[1],c[n+2]=h[0],c[n+3]=255;u.putImageData(i,e-p.x,t-p.y)},n.blitImage=function(e,t,o,s,i,n){l.true_color?a(e,t,o,s,i,n):r(e,t,o,s,i,n)},n.blitRgbImage=function(e,t,a,s,i,n){l.true_color?o(e,t,a,s,i,n):r(e,t,a,s,i,n)},n.blitStringImage=function(e,t,o){var a=new Image;a.onload=function(){u.drawImage(a,t-p.x,o-p.y)},a.src=e},n.changeCursor=function(e,t,o,a,r,s){return l.cursor_uri===!1?void Util.Warn("changeCursor called but no cursor data URI support"):void(l.true_color?changeCursor(l.target,e,t,o,a,r,s):changeCursor(l.target,e,t,o,a,r,s,l.colourMap))},n.defaultCursor=function(){l.target.style.cursor="default"},t()}function changeCursor(e,t,o,a,r,s,i,n){"use strict";var l,u,d,c,p,h,m,f,g,v,b=[];for(b.push16le=function(e){this.push(255&e,e>>8&255)},b.push32le=function(e){this.push(255&e,e>>8&255,e>>16&255,e>>24&255)},u=40,d=s*i*4,p=Math.ceil(s*i/8),c=Math.ceil(s*i/8),b.push16le(0),b.push16le(2),b.push16le(1),b.push(s),b.push(i),b.push(0),b.push(0),b.push16le(a),b.push16le(r),b.push32le(u+d+p+c),b.push32le(22),b.push32le(u),b.push32le(s),b.push32le(2*i),b.push16le(1),b.push16le(32),b.push32le(0),b.push32le(p+c),b.push32le(0),b.push32le(0),b.push32le(0),b.push32le(0),v=i-1;v>=0;v-=1)for(g=0;s>g;g+=1)m=v*Math.ceil(s/8)+Math.floor(g/8),f=o[m]<<g%8&128?255:0,n?(m=s*v+g,l=n[t[m]],b.push(l[2]),b.push(l[1]),b.push(l[0]),b.push(f)):(m=4*(s*v+g),b.push(t[m+2]),b.push(t[m+1]),b.push(t[m]),b.push(f));for(v=0;i>v;v+=1)for(g=0;g<Math.ceil(s/8);g+=1)b.push(0);for(v=0;i>v;v+=1)for(g=0;g<Math.ceil(s/8);g+=1)b.push(0);h="data:image/x-icon;base64,"+Base64.encode(b),e.style.cursor="url("+h+") "+a+" "+r+", default"}